
/**
 * @autor Felipe Sánchez Martínez
 * 
 * Class for illustrating the pasing or arguments by value
 */

public class MyClass {

	/**
	 * Function taking as argument a scalar type (double)
	 */
	public static void f1 (double d) {
		d=0.42;
        	System.out.println("Inside f1; d = "+d);
        }
	
	/**
	 * Function taking as argument a reference to an object of type Human 
	 */
	public static void f2 (Human h) {
		h.setName("Peter"); //The object is updated
		System.out.println("Inside f2; h = "+h.toString());
	}
	
	/**
	 * Function taking as argument a reference to an object of type Human. 
	 */
	public static void f3 (Human h) {
		h = new Human("Sara"); //Memory is allocated for a new object
		System.out.println("Inside f3; h = "+h.toString());
	}
	
    public static void main(String args[]) {
    	double d=0.33;
    	System.out.println("Before f1; d = "+d);
    	f1(d);
    	System.out.println("After  f1; d = "+d);
    	System.out.println("");
 
    	Human h = new Human("John");
    	System.out.println("Before f2; h = "+h.toString());
    	f2(h);
    	System.out.println("After  f2; h = "+h.toString());
    	System.out.println("");
    	
    	h = new Human("John");
    	System.out.println("Before f3; h = "+h.toString());
    	f3(h);
    	System.out.println("After  f3; h = "+h.toString());
    	System.out.println("");
    }
}
